


<!DOCTYPE html>
<html lang="en" class="">
  <head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>
<head prefix="og: http://ogp.me/ns# fb: http://ogp.me/ns/fb# object: http://ogp.me/ns/object# article: http://ogp.me/ns/article# profile: http://ogp.me/ns/profile#">
    <meta charset='utf-8'>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta http-equiv="Content-Language" content="en">
    <meta name="viewport" content="width=1020">
    
    
    <title>kiwanami/emacs-calfw · GitHub</title>
    <link rel="search" type="application/opensearchdescription+xml" href="/opensearch.xml" title="GitHub">
    <link rel="fluid-icon" href="https://github.com/fluidicon.png" title="GitHub">
    <link rel="apple-touch-icon" sizes="57x57" href="/apple-touch-icon-114.png">
    <link rel="apple-touch-icon" sizes="114x114" href="/apple-touch-icon-114.png">
    <link rel="apple-touch-icon" sizes="72x72" href="/apple-touch-icon-144.png">
    <link rel="apple-touch-icon" sizes="144x144" href="/apple-touch-icon-144.png">
    <meta property="fb:app_id" content="1401488693436528">

      <meta content="@github" name="twitter:site" /><meta content="summary" name="twitter:card" /><meta content="kiwanami/emacs-calfw" name="twitter:title" /><meta content="emacs-calfw - A calendar framework for Emacs" name="twitter:description" /><meta content="https://avatars3.githubusercontent.com/u/158801?v=3&amp;s=400" name="twitter:image:src" />
      <meta content="GitHub" property="og:site_name" /><meta content="object" property="og:type" /><meta content="https://avatars3.githubusercontent.com/u/158801?v=3&amp;s=400" property="og:image" /><meta content="kiwanami/emacs-calfw" property="og:title" /><meta content="https://github.com/kiwanami/emacs-calfw" property="og:url" /><meta content="emacs-calfw - A calendar framework for Emacs" property="og:description" />
      <meta name="browser-stats-url" content="https://api.github.com/_private/browser/stats">
    <meta name="browser-errors-url" content="https://api.github.com/_private/browser/errors">
    <link rel="assets" href="https://assets-cdn.github.com/">
    
    <meta name="pjax-timeout" content="1000">
    

    <meta name="msapplication-TileImage" content="/windows-tile.png">
    <meta name="msapplication-TileColor" content="#ffffff">
    <meta name="selected-link" value="repo_source" data-pjax-transient>

    <meta name="google-site-verification" content="KT5gs8h0wvaagLKAVWq8bbeNwnZZK1r1XQysX3xurLU">
    <meta name="google-analytics" content="UA-3769691-2">

<meta content="collector.githubapp.com" name="octolytics-host" /><meta content="collector-cdn.github.com" name="octolytics-script-host" /><meta content="github" name="octolytics-app-id" /><meta content="B081995E:7D28:114B0471:561EC48E" name="octolytics-dimension-request_id" />

<meta content="Rails, view, files#disambiguate" data-pjax-transient="true" name="analytics-event" />


  <meta class="js-ga-set" name="dimension1" content="Logged Out">
    <meta class="js-ga-set" name="dimension4" content="Current repo nav">




    <meta name="is-dotcom" content="true">
        <meta name="hostname" content="github.com">
    <meta name="user-login" content="">

      <link rel="mask-icon" href="https://assets-cdn.github.com/pinned-octocat.svg" color="#4078c0">
      <link rel="icon" type="image/x-icon" href="https://assets-cdn.github.com/favicon.ico">

      <!-- </textarea> --><!-- '"` --><meta content="authenticity_token" name="csrf-param" />
<meta content="Mb4ktH2/D49iXGsod6fKJBTPkY7IIngbUU3CTBXWUNRiovipmfwdeA92XNxjyRLrI9KklrVd05Ug5JHphwtQ7w==" name="csrf-token" />
    <meta content="0879de573ae9525ee1a481d953ec0833e3e151cd" name="form-nonce" />

    <link crossorigin="anonymous" href="https://assets-cdn.github.com/assets/github-1c72e5e1cbdeae0d6a25ee0e6f07ae0100db5696d3f5f10ed2acf1f0885ef5f0.css" media="all" rel="stylesheet" />
    <link crossorigin="anonymous" href="https://assets-cdn.github.com/assets/github2-2636fb226b1998b444ae391afdb526dd51ffc15c99c699d9bb1e2d4086442e30.css" media="all" rel="stylesheet" />
    
    
    


    <meta http-equiv="x-pjax-version" content="a47671ed3bd9b26fa9a675f405b36d67">

      
  <meta name="description" content="emacs-calfw - A calendar framework for Emacs">
  <meta name="go-import" content="github.com/kiwanami/emacs-calfw git https://github.com/kiwanami/emacs-calfw.git">

  <meta content="158801" name="octolytics-dimension-user_id" /><meta content="kiwanami" name="octolytics-dimension-user_login" /><meta content="1205981" name="octolytics-dimension-repository_id" /><meta content="kiwanami/emacs-calfw" name="octolytics-dimension-repository_nwo" /><meta content="true" name="octolytics-dimension-repository_public" /><meta content="false" name="octolytics-dimension-repository_is_fork" /><meta content="1205981" name="octolytics-dimension-repository_network_root_id" /><meta content="kiwanami/emacs-calfw" name="octolytics-dimension-repository_network_root_nwo" />
  <link href="https://github.com/kiwanami/emacs-calfw/commits/master.atom" rel="alternate" title="Recent Commits to emacs-calfw:master" type="application/atom+xml">

  </head>


  <body class="logged_out   env-production  vis-public">
    <a href="#start-of-content" tabindex="1" class="accessibility-aid js-skip-to-content">Skip to content</a>

    
    
    



      
      <div class="header header-logged-out" role="banner">
  <div class="container clearfix">

    <a class="header-logo-wordmark" href="https://github.com/" data-ga-click="(Logged out) Header, go to homepage, icon:logo-wordmark">
      <span class="mega-octicon octicon-logo-github"></span>
    </a>

    <div class="header-actions" role="navigation">
        <a class="btn btn-primary" href="/join" data-ga-click="(Logged out) Header, clicked Sign up, text:sign-up">Sign up</a>
      <a class="btn" href="/login?return_to=%2Fkiwanami%2Femacs-calfw" data-ga-click="(Logged out) Header, clicked Sign in, text:sign-in">Sign in</a>
    </div>

    <div class="site-search repo-scope js-site-search" role="search">
      <!-- </textarea> --><!-- '"` --><form accept-charset="UTF-8" action="/kiwanami/emacs-calfw/search" class="js-site-search-form" data-global-search-url="/search" data-repo-search-url="/kiwanami/emacs-calfw/search" method="get"><div style="margin:0;padding:0;display:inline"><input name="utf8" type="hidden" value="&#x2713;" /></div>
  <label class="js-chromeless-input-container form-control">
    <div class="scope-badge">This repository</div>
    <input type="text"
      class="js-site-search-focus js-site-search-field is-clearable chromeless-input"
      data-hotkey="s"
      name="q"
      placeholder="Search"
      aria-label="Search this repository"
      data-global-scope-placeholder="Search GitHub"
      data-repo-scope-placeholder="Search"
      tabindex="1"
      autocapitalize="off">
  </label>
</form>
    </div>

      <ul class="header-nav left" role="navigation">
          <li class="header-nav-item">
            <a class="header-nav-link" href="/explore" data-ga-click="(Logged out) Header, go to explore, text:explore">Explore</a>
          </li>
          <li class="header-nav-item">
            <a class="header-nav-link" href="/features" data-ga-click="(Logged out) Header, go to features, text:features">Features</a>
          </li>
          <li class="header-nav-item">
            <a class="header-nav-link" href="https://enterprise.github.com/" data-ga-click="(Logged out) Header, go to enterprise, text:enterprise">Enterprise</a>
          </li>
          <li class="header-nav-item">
            <a class="header-nav-link" href="/pricing" data-ga-click="(Logged out) Header, go to pricing, text:pricing">Pricing</a>
          </li>
      </ul>

  </div>
</div>



    <div id="start-of-content" class="accessibility-aid"></div>

    <div id="js-flash-container">
</div>


    <div role="main" class="main-content">
        <div itemscope itemtype="http://schema.org/WebPage">
    <div class="pagehead repohead instapaper_ignore readability-menu">

      <div class="container">

        <div class="clearfix">
          

<ul class="pagehead-actions">

  <li>
      <a href="/login?return_to=%2Fkiwanami%2Femacs-calfw"
    class="btn btn-sm btn-with-count tooltipped tooltipped-n"
    aria-label="You must be signed in to watch a repository" rel="nofollow">
    <span class="octicon octicon-eye"></span>
    Watch
  </a>
  <a class="social-count" href="/kiwanami/emacs-calfw/watchers">
    40
  </a>

  </li>

  <li>
      <a href="/login?return_to=%2Fkiwanami%2Femacs-calfw"
    class="btn btn-sm btn-with-count tooltipped tooltipped-n"
    aria-label="You must be signed in to star a repository" rel="nofollow">
    <span class="octicon octicon-star"></span>
    Star
  </a>

    <a class="social-count js-social-count" href="/kiwanami/emacs-calfw/stargazers">
      426
    </a>

  </li>

  <li>
      <a href="/login?return_to=%2Fkiwanami%2Femacs-calfw"
        class="btn btn-sm btn-with-count tooltipped tooltipped-n"
        aria-label="You must be signed in to fork a repository" rel="nofollow">
        <span class="octicon octicon-repo-forked"></span>
        Fork
      </a>

    <a href="/kiwanami/emacs-calfw/network" class="social-count">
      30
    </a>
  </li>
</ul>

          <h1 itemscope itemtype="http://data-vocabulary.org/Breadcrumb" class="entry-title public ">
  <span class="mega-octicon octicon-repo"></span>
  <span class="author"><a href="/kiwanami" class="url fn" itemprop="url" rel="author"><span itemprop="title">kiwanami</span></a></span><!--
--><span class="path-divider">/</span><!--
--><strong><a href="/kiwanami/emacs-calfw" data-pjax="#js-repo-pjax-container">emacs-calfw</a></strong>

  <span class="page-context-loader">
    <img alt="" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
  </span>

</h1>

        </div>
      </div>
    </div>

    <div class="container">
      <div class="repository-with-sidebar repo-container new-discussion-timeline with-full-navigation">
        <div class="repository-sidebar clearfix">
          
<nav class="sunken-menu repo-nav js-repo-nav js-sidenav-container-pjax js-octicon-loaders"
     role="navigation"
     data-pjax="#js-repo-pjax-container"
     data-issue-count-url="/kiwanami/emacs-calfw/issues/counts">
  <ul class="sunken-menu-group">
    <li class="tooltipped tooltipped-w" aria-label="Code">
      <a href="/kiwanami/emacs-calfw" aria-label="Code" aria-selected="true" class="js-selected-navigation-item selected sunken-menu-item" data-hotkey="g c" data-selected-links="repo_source repo_downloads repo_commits repo_releases repo_tags repo_branches /kiwanami/emacs-calfw">
        <span class="octicon octicon-code"></span> <span class="full-word">Code</span>
        <img alt="" class="mini-loader" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
</a>    </li>

      <li class="tooltipped tooltipped-w" aria-label="Issues">
        <a href="/kiwanami/emacs-calfw/issues" aria-label="Issues" class="js-selected-navigation-item sunken-menu-item" data-hotkey="g i" data-selected-links="repo_issues repo_labels repo_milestones /kiwanami/emacs-calfw/issues">
          <span class="octicon octicon-issue-opened"></span> <span class="full-word">Issues</span>
          <span class="js-issue-replace-counter"></span>
          <img alt="" class="mini-loader" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
</a>      </li>

    <li class="tooltipped tooltipped-w" aria-label="Pull requests">
      <a href="/kiwanami/emacs-calfw/pulls" aria-label="Pull requests" class="js-selected-navigation-item sunken-menu-item" data-hotkey="g p" data-selected-links="repo_pulls /kiwanami/emacs-calfw/pulls">
          <span class="octicon octicon-git-pull-request"></span> <span class="full-word">Pull requests</span>
          <span class="js-pull-replace-counter"></span>
          <img alt="" class="mini-loader" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
</a>    </li>

  </ul>
  <div class="sunken-menu-separator"></div>
  <ul class="sunken-menu-group">

    <li class="tooltipped tooltipped-w" aria-label="Pulse">
      <a href="/kiwanami/emacs-calfw/pulse" aria-label="Pulse" class="js-selected-navigation-item sunken-menu-item" data-selected-links="pulse /kiwanami/emacs-calfw/pulse">
        <span class="octicon octicon-pulse"></span> <span class="full-word">Pulse</span>
        <img alt="" class="mini-loader" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
</a>    </li>

    <li class="tooltipped tooltipped-w" aria-label="Graphs">
      <a href="/kiwanami/emacs-calfw/graphs" aria-label="Graphs" class="js-selected-navigation-item sunken-menu-item" data-selected-links="repo_graphs repo_contributors /kiwanami/emacs-calfw/graphs">
        <span class="octicon octicon-graph"></span> <span class="full-word">Graphs</span>
        <img alt="" class="mini-loader" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
</a>    </li>
  </ul>


</nav>

            <div class="only-with-full-nav">
                
<div class="js-clone-url clone-url open"
  data-protocol-type="http">
  <h3 class="text-small"><span class="text-emphasized">HTTPS</span> clone URL</h3>
  <div class="input-group js-zeroclipboard-container">
    <input type="text" class="input-mini text-small input-monospace js-url-field js-zeroclipboard-target"
           value="https://github.com/kiwanami/emacs-calfw.git" readonly="readonly" aria-label="HTTPS clone URL">
    <span class="input-group-button">
      <button aria-label="Copy to clipboard" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><span class="octicon octicon-clippy"></span></button>
    </span>
  </div>
</div>

  
<div class="js-clone-url clone-url "
  data-protocol-type="subversion">
  <h3 class="text-small"><span class="text-emphasized">Subversion</span> checkout URL</h3>
  <div class="input-group js-zeroclipboard-container">
    <input type="text" class="input-mini text-small input-monospace js-url-field js-zeroclipboard-target"
           value="https://github.com/kiwanami/emacs-calfw" readonly="readonly" aria-label="Subversion checkout URL">
    <span class="input-group-button">
      <button aria-label="Copy to clipboard" class="js-zeroclipboard btn btn-sm zeroclipboard-button tooltipped tooltipped-s" data-copied-hint="Copied!" type="button"><span class="octicon octicon-clippy"></span></button>
    </span>
  </div>
</div>



<div class="clone-options text-small">You can clone with
  <!-- </textarea> --><!-- '"` --><form accept-charset="UTF-8" action="/users/set_protocol?protocol_selector=http&amp;protocol_type=clone" class="inline-form js-clone-selector-form " data-form-nonce="0879de573ae9525ee1a481d953ec0833e3e151cd" data-remote="true" method="post"><div style="margin:0;padding:0;display:inline"><input name="utf8" type="hidden" value="&#x2713;" /><input name="authenticity_token" type="hidden" value="QEM1f0ao9uLKso6CSSOSy19G/BacHka3rCf366onQeNe1i3CweL2S31jTjf09oClJzmTtcQDKLxjRvrPsM6a0w==" /></div><button class="btn-link js-clone-selector" data-protocol="http" type="submit">HTTPS</button></form> or <!-- </textarea> --><!-- '"` --><form accept-charset="UTF-8" action="/users/set_protocol?protocol_selector=subversion&amp;protocol_type=clone" class="inline-form js-clone-selector-form " data-form-nonce="0879de573ae9525ee1a481d953ec0833e3e151cd" data-remote="true" method="post"><div style="margin:0;padding:0;display:inline"><input name="utf8" type="hidden" value="&#x2713;" /><input name="authenticity_token" type="hidden" value="KgySeNaeyX5C00UewiqQG3vfNUpBgsPsfuRvk8NGN+hMiadI/vMyMnLONZaPy6jjE2Z9yBcvi11IVqht4i6Ksw==" /></div><button class="btn-link js-clone-selector" data-protocol="subversion" type="submit">Subversion</button></form>.
  <a href="https://help.github.com/articles/which-remote-url-should-i-use" class="help tooltipped tooltipped-n" aria-label="Get help on which URL is right for you.">
    <span class="octicon octicon-question"></span>
  </a>
</div>

              <a href="/kiwanami/emacs-calfw/archive/master.zip"
                 class="btn btn-sm sidebar-button"
                 aria-label="Download the contents of kiwanami/emacs-calfw as a zip file"
                 title="Download the contents of kiwanami/emacs-calfw as a zip file"
                 rel="nofollow">
                <span class="octicon octicon-cloud-download"></span>
                Download ZIP
              </a>
            </div>
        </div>
        <div id="js-repo-pjax-container" class="repository-content context-loader-container" data-pjax-container>

          
<span id="js-show-full-navigation"></span>

  <div class="repository-meta js-details-container ">
    <div class="repository-description">
      A calendar framework for Emacs
    </div>


</div>


<div class="overall-summary overall-summary-bottomless">

  <div class="stats-switcher-viewport js-stats-switcher-viewport">
    <div class="stats-switcher-wrapper">
    <ul class="numbers-summary">
      <li class="commits">
        <a data-pjax href="/kiwanami/emacs-calfw/commits/master">
            <span class="octicon octicon-history"></span>
            <span class="num text-emphasized">
              188
            </span>
            commits
        </a>
      </li>
      <li>
        <a data-pjax href="/kiwanami/emacs-calfw/branches">
          <span class="octicon octicon-git-branch"></span>
          <span class="num text-emphasized">
            4
          </span>
          branches
        </a>
      </li>

      <li>
        <a data-pjax href="/kiwanami/emacs-calfw/releases">
          <span class="octicon octicon-tag"></span>
          <span class="num text-emphasized">
            9
          </span>
          releases
        </a>
      </li>

      <li>
        
  <a href="/kiwanami/emacs-calfw/graphs/contributors">
    <span class="octicon octicon-organization"></span>
    <span class="num text-emphasized">
      12
    </span>
    contributors
  </a>
      </li>
    </ul>

      <div class="repository-lang-stats">
        <ol class="repository-lang-stats-numbers">
          <li>
              <a href="/kiwanami/emacs-calfw/search?l=emacs-lisp">
                <span class="color-block language-color" style="background-color:#c065db;"></span>
                <span class="lang">Emacs Lisp</span>
                <span class="percent">100.0%</span>
              </a>
          </li>
        </ol>
      </div>
    </div>
  </div>

</div>

  <div class="repository-lang-stats-graph js-toggle-lang-stats" title="Click for language details">
    <span class="language-color" aria-label="Emacs Lisp 100.0%" style="width:100.0%; background-color:#c065db;" itemprop="keywords">Emacs Lisp</span>
  </div>

<include-fragment src="/kiwanami/emacs-calfw/show_partial?partial=tree%2Frecently_touched_branches_list"></include-fragment>

  <div class="file-navigation in-mid-page">
  <a href="/kiwanami/emacs-calfw/find/master"
        class="js-show-file-finder btn btn-sm empty-icon tooltipped tooltipped-s right"
        data-pjax
        data-hotkey="t"
        aria-label="Quickly jump between files"
        data-ga-click="Repository, find file, location:repo overview">
    <span class="octicon octicon-list-unordered"></span>
  </a>
    <a href="/kiwanami/emacs-calfw/compare" aria-label="Compare, review, create a pull request" class="btn btn-sm btn-primary tooltipped tooltipped-se left compare-button" aria-label="Compare &amp; review" data-pjax data-ga-click="Repository, go to compare view, location:repo overview; icon:git-compare">
      <span class="octicon octicon-git-compare"></span>
    </a>

  
<div class="select-menu js-menu-container js-select-menu left">
  <span class="btn btn-sm select-menu-button js-menu-target css-truncate" data-hotkey="w"
    title="master"
    role="button" aria-label="Switch branches or tags" tabindex="0" aria-haspopup="true">
    <i>Branch:</i>
    <span class="js-select-button css-truncate-target">master</span>
  </span>

  <div class="select-menu-modal-holder js-menu-content js-navigation-container" data-pjax aria-hidden="true">

    <div class="select-menu-modal">
      <div class="select-menu-header">
        <span class="select-menu-title">Switch branches/tags</span>
        <span class="octicon octicon-x js-menu-close" role="button" aria-label="Close"></span>
      </div>

      <div class="select-menu-filters">
        <div class="select-menu-text-filter">
          <input type="text" aria-label="Filter branches/tags" id="context-commitish-filter-field" class="js-filterable-field js-navigation-enable" placeholder="Filter branches/tags">
        </div>
        <div class="select-menu-tabs">
          <ul>
            <li class="select-menu-tab">
              <a href="#" data-tab-filter="branches" data-filter-placeholder="Filter branches/tags" class="js-select-menu-tab" role="tab">Branches</a>
            </li>
            <li class="select-menu-tab">
              <a href="#" data-tab-filter="tags" data-filter-placeholder="Find a tag…" class="js-select-menu-tab" role="tab">Tags</a>
            </li>
          </ul>
        </div>
      </div>

      <div class="select-menu-list select-menu-tab-bucket js-select-menu-tab-bucket" data-tab-filter="branches" role="menu">

        <div data-filterable-for="context-commitish-filter-field" data-filterable-type="substring">


            <a class="select-menu-item js-navigation-item js-navigation-open selected"
               href="/kiwanami/emacs-calfw/tree/master"
               data-name="master"
               data-skip-pjax="true"
               rel="nofollow">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <span class="select-menu-item-text css-truncate-target" title="master">
                master
              </span>
            </a>
            <a class="select-menu-item js-navigation-item js-navigation-open "
               href="/kiwanami/emacs-calfw/tree/multiline"
               data-name="multiline"
               data-skip-pjax="true"
               rel="nofollow">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <span class="select-menu-item-text css-truncate-target" title="multiline">
                multiline
              </span>
            </a>
            <a class="select-menu-item js-navigation-item js-navigation-open "
               href="/kiwanami/emacs-calfw/tree/v1.0b"
               data-name="v1.0b"
               data-skip-pjax="true"
               rel="nofollow">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <span class="select-menu-item-text css-truncate-target" title="v1.0b">
                v1.0b
              </span>
            </a>
            <a class="select-menu-item js-navigation-item js-navigation-open "
               href="/kiwanami/emacs-calfw/tree/v1.0b2"
               data-name="v1.0b2"
               data-skip-pjax="true"
               rel="nofollow">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <span class="select-menu-item-text css-truncate-target" title="v1.0b2">
                v1.0b2
              </span>
            </a>
        </div>

          <div class="select-menu-no-results">Nothing to show</div>
      </div>

      <div class="select-menu-list select-menu-tab-bucket js-select-menu-tab-bucket" data-tab-filter="tags">
        <div data-filterable-for="context-commitish-filter-field" data-filterable-type="substring">


            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v1.5"
                 data-name="v1.5"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v1.5">v1.5</a>
            </div>
            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v1.4"
                 data-name="v1.4"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v1.4">v1.4</a>
            </div>
            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v1.3"
                 data-name="v1.3"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v1.3">v1.3</a>
            </div>
            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v1.2"
                 data-name="v1.2"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v1.2">v1.2</a>
            </div>
            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v1.1"
                 data-name="v1.1"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v1.1">v1.1</a>
            </div>
            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v1.0"
                 data-name="v1.0"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v1.0">v1.0</a>
            </div>
            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v0.2.1"
                 data-name="v0.2.1"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v0.2.1">v0.2.1</a>
            </div>
            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v0.2"
                 data-name="v0.2"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v0.2">v0.2</a>
            </div>
            <div class="select-menu-item js-navigation-item ">
              <span class="select-menu-item-icon octicon octicon-check"></span>
              <a href="/kiwanami/emacs-calfw/tree/v0.1"
                 data-name="v0.1"
                 data-skip-pjax="true"
                 rel="nofollow"
                 class="js-navigation-open select-menu-item-text css-truncate-target"
                 title="v0.1">v0.1</a>
            </div>
        </div>

        <div class="select-menu-no-results">Nothing to show</div>
      </div>

    </div>
  </div>
</div>


  <div class="breadcrumb"><span class="repo-root js-repo-root"><span itemscope="" itemtype="http://data-vocabulary.org/Breadcrumb"><a href="/kiwanami/emacs-calfw" class="" data-branch="master" data-pjax="true" itemscope="url"><span itemprop="title">emacs-calfw</span></a></span></span><span class="separator">/</span>
  <span class="tooltipped tooltipped-e disabled text-muted" aria-label="You must be signed in to make or propose changes">
    <span class="octicon octicon-plus"></span>
  </span>
</div>
</div>





  <div class="commit-tease js-details-container">
    <span class="right">
      Latest commit
      <a class="commit-tease-sha" href="/kiwanami/emacs-calfw/commit/50e0e0261568f84f31fe7f87c9f863e21d30132f" data-pjax>
        50e0e0
      </a>
      <time datetime="2015-09-24T02:49:37Z" is="relative-time">Sep 24, 2015</time>
    </span>


    <span>
      <img alt="@kiwanami" class="avatar" height="20" src="https://avatars0.githubusercontent.com/u/158801?v=3&amp;s=40" width="20" />
      <a href="/kiwanami" class="user-mention" rel="author">kiwanami</a></span>


        <a href="/kiwanami/emacs-calfw/commit/50e0e0261568f84f31fe7f87c9f863e21d30132f" class="message" data-pjax="true" title="Bump version 1.5">Bump version 1.5</a>
    </span>

  </div>


<div class="file-wrap">
  <a href="/kiwanami/emacs-calfw/tree/50e0e0261568f84f31fe7f87c9f863e21d30132f" class="hidden js-permalink-shortcut" data-hotkey="y">Permalink</a>

  <table class="files js-navigation-container js-active-navigation-container" data-pjax>


    <tbody>
      <tr class="warning include-fragment-error">
        <td class="icon"><span class="octicon octicon-alert"></span></td>
        <td class="content" colspan="3">Failed to load latest commit information.</td>
      </tr>

        <tr class="js-navigation-item">
          <td class="icon">
            <span class="octicon octicon-file-text"></span>
            <img alt="" class="spinner" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
          </td>
          <td class="content">
            <span class="css-truncate css-truncate-target"><a href="/kiwanami/emacs-calfw/blob/master/calfw-cal.el" class="js-directory-link js-navigation-open" id="0aa3330392624e2ca0677390701593ff-72759473ea0691060e2caf12a010a7db1c9be233" title="calfw-cal.el">calfw-cal.el</a></span>
          </td>
          <td class="message">
            <span class="css-truncate css-truncate-target">
              <a href="/kiwanami/emacs-calfw/commit/8fa755a9835023ead252f9e48eb207b93d661617" class="message" data-pjax="true" title="Bug fixed: wrong folding for block scheduling

When block schedules are scheduled on the same block period, the folding
function which translates from diary to calfw, can not distinguish them,
because the function make an alist by the schedule period as a key.
This patch corrects the folding function and the schedule items are
displayed as users expect. (thx abetatsuya)">Bug fixed: wrong folding for block scheduling</a>
            </span>
          </td>
          <td class="age">
            <span class="css-truncate css-truncate-target"><time datetime="2015-06-06T02:58:31Z" is="time-ago">Jun 6, 2015</time></span>
          </td>
        </tr>
        <tr class="js-navigation-item">
          <td class="icon">
            <span class="octicon octicon-file-text"></span>
            <img alt="" class="spinner" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
          </td>
          <td class="content">
            <span class="css-truncate css-truncate-target"><a href="/kiwanami/emacs-calfw/blob/master/calfw-howm.el" class="js-directory-link js-navigation-open" id="58a20bd420da48d94c1fea6f660930cd-418f8559fbb41658cff6c2fedd02305675e4d8dc" title="calfw-howm.el">calfw-howm.el</a></span>
          </td>
          <td class="message">
            <span class="css-truncate css-truncate-target">
              <a href="/kiwanami/emacs-calfw/commit/2904a0b4bcce2f7868e5b367f9c2e1e6682f43c9" class="message" data-pjax="true" title="Fix cursor jump bug (Fix #40)">Fix cursor jump bug (Fix</a> <a href="https://github.com/kiwanami/emacs-calfw/issues/40" class="issue-link" title="Cursor jumps to random position in buffer after calling calfw buffer.">#40</a><a href="/kiwanami/emacs-calfw/commit/2904a0b4bcce2f7868e5b367f9c2e1e6682f43c9" class="message" data-pjax="true" title="Fix cursor jump bug (Fix #40)">)</a>
            </span>
          </td>
          <td class="age">
            <span class="css-truncate css-truncate-target"><time datetime="2015-02-06T12:51:21Z" is="time-ago">Feb 6, 2015</time></span>
          </td>
        </tr>
        <tr class="js-navigation-item">
          <td class="icon">
            <span class="octicon octicon-file-text"></span>
            <img alt="" class="spinner" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
          </td>
          <td class="content">
            <span class="css-truncate css-truncate-target"><a href="/kiwanami/emacs-calfw/blob/master/calfw-ical.el" class="js-directory-link js-navigation-open" id="2c7cfad270be64048896ad84e24a1dbe-9855f9dba64e8ed9c2110579466abe7d28ecbf2b" title="calfw-ical.el">calfw-ical.el</a></span>
          </td>
          <td class="message">
            <span class="css-truncate css-truncate-target">
              <a href="/kiwanami/emacs-calfw/commit/263d5f37fff53f16165f347ee86dd35e54a93693" class="message" data-pjax="true" title="Fix wrong function name">Fix wrong function name</a>
            </span>
          </td>
          <td class="age">
            <span class="css-truncate css-truncate-target"><time datetime="2015-06-10T05:01:00Z" is="time-ago">Jun 10, 2015</time></span>
          </td>
        </tr>
        <tr class="js-navigation-item">
          <td class="icon">
            <span class="octicon octicon-file-text"></span>
            <img alt="" class="spinner" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
          </td>
          <td class="content">
            <span class="css-truncate css-truncate-target"><a href="/kiwanami/emacs-calfw/blob/master/calfw-org.el" class="js-directory-link js-navigation-open" id="6dbd6a07e4da4ab3475b6dafc6854127-2e40236069e6103e1061d4734b30c75bb6114208" title="calfw-org.el">calfw-org.el</a></span>
          </td>
          <td class="message">
            <span class="css-truncate css-truncate-target">
              <a href="/kiwanami/emacs-calfw/commit/240b4cbc38d3dab2f1e51648fb88a614b8ac0d3d" class="message" data-pjax="true" title="add variable for org agenda item foreground color

- add variable cfw:org-face-agenda-item-foreground-color">add variable for org agenda item foreground color</a>
            </span>
          </td>
          <td class="age">
            <span class="css-truncate css-truncate-target"><time datetime="2015-09-08T13:15:12Z" is="time-ago">Sep 8, 2015</time></span>
          </td>
        </tr>
        <tr class="js-navigation-item">
          <td class="icon">
            <span class="octicon octicon-file-text"></span>
            <img alt="" class="spinner" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
          </td>
          <td class="content">
            <span class="css-truncate css-truncate-target"><a href="/kiwanami/emacs-calfw/blob/master/calfw.el" class="js-directory-link js-navigation-open" id="205a622fae1af525c7ceb8c8783b707c-879ada94f57653aea0b69fda8581d417d5f5abed" title="calfw.el">calfw.el</a></span>
          </td>
          <td class="message">
            <span class="css-truncate css-truncate-target">
              <a href="/kiwanami/emacs-calfw/commit/50e0e0261568f84f31fe7f87c9f863e21d30132f" class="message" data-pjax="true" title="Bump version 1.5">Bump version 1.5</a>
            </span>
          </td>
          <td class="age">
            <span class="css-truncate css-truncate-target"><time datetime="2015-09-24T02:49:37Z" is="time-ago">Sep 24, 2015</time></span>
          </td>
        </tr>
        <tr class="js-navigation-item">
          <td class="icon">
            <span class="octicon octicon-file-text"></span>
            <img alt="" class="spinner" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
          </td>
          <td class="content">
            <span class="css-truncate css-truncate-target"><a href="/kiwanami/emacs-calfw/blob/master/calfw.juth" class="js-directory-link js-navigation-open" id="d2ee0cba02ce17ce12ae5789cff05b7b-67ab2d9b279f21aa8be10192007fa17245a7ecd2" title="calfw.juth">calfw.juth</a></span>
          </td>
          <td class="message">
            <span class="css-truncate css-truncate-target">
              <a href="/kiwanami/emacs-calfw/commit/cd626f81ba18656d3b84dd8a51d11cc5e7de5e6e" class="message" data-pjax="true" title="Updated diagram.">Updated diagram.</a>
            </span>
          </td>
          <td class="age">
            <span class="css-truncate css-truncate-target"><time datetime="2011-09-02T06:11:59Z" is="time-ago">Sep 2, 2011</time></span>
          </td>
        </tr>
        <tr class="js-navigation-item">
          <td class="icon">
            <span class="octicon octicon-file-text"></span>
            <img alt="" class="spinner" height="16" src="https://assets-cdn.github.com/images/spinners/octocat-spinner-32.gif" width="16" />
          </td>
          <td class="content">
            <span class="css-truncate css-truncate-target"><a href="/kiwanami/emacs-calfw/blob/master/readme.md" class="js-directory-link js-navigation-open" id="0730bb7c2e8f9ea2438b52e419dd86c9-d9f67f704e900533da5623556377865e614c28e3" title="readme.md">readme.md</a></span>
          </td>
          <td class="message">
            <span class="css-truncate css-truncate-target">
              <a href="/kiwanami/emacs-calfw/commit/50e0e0261568f84f31fe7f87c9f863e21d30132f" class="message" data-pjax="true" title="Bump version 1.5">Bump version 1.5</a>
            </span>
          </td>
          <td class="age">
            <span class="css-truncate css-truncate-target"><time datetime="2015-09-24T02:49:37Z" is="time-ago">Sep 24, 2015</time></span>
          </td>
        </tr>
    </tbody>
  </table>

</div>


  <div id="readme" class="boxed-group flush clearfix announce instapaper_body md">
    <h3>
      <span class="octicon octicon-book"></span>
      readme.md
    </h3>

    <article class="markdown-body entry-content" itemprop="mainContentOfPage"><h1><a id="user-content-calfw---a-calendar-framework-for-emacs" class="anchor" href="#calfw---a-calendar-framework-for-emacs" aria-hidden="true"><span class="octicon octicon-link"></span></a>Calfw - A calendar framework for Emacs</h1>

<h2><a id="user-content-what-is-calfw" class="anchor" href="#what-is-calfw" aria-hidden="true"><span class="octicon octicon-link"></span></a>What is calfw?</h2>

<p>This program displays a calendar view in the Emacs buffer.</p>

<p><a href="https://camo.githubusercontent.com/bcf0ca5fd834e2ea161099edfcb8bc969edebbc1/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f4f6e6a4b6742486174306b48733078702d39453545302e706e673f77696474683d363030" target="_blank"><img src="https://camo.githubusercontent.com/bcf0ca5fd834e2ea161099edfcb8bc969edebbc1/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f4f6e6a4b6742486174306b48733078702d39453545302e706e673f77696474683d363030" alt="Calfw image" data-canonical-src="https://cacoo.com/diagrams/OnjKgBHat0kHs0xp-9E5E0.png?width=600" style="max-width:100%;"></a></p>

<h3><a id="user-content-screenshots" class="anchor" href="#screenshots" aria-hidden="true"><span class="octicon octicon-link"></span></a>Screenshots</h3>

<p>Currently, calfw has 4 views, month, 1week, 2week and day view.
<a href="https://camo.githubusercontent.com/7fe05e2e0f9c31eb5cc8f48143bc8d932dbe3bfd/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f4f6e6a4b6742486174306b48733078702d46333735362e706e673f77696474683d363030" target="_blank"><img src="https://camo.githubusercontent.com/7fe05e2e0f9c31eb5cc8f48143bc8d932dbe3bfd/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f4f6e6a4b6742486174306b48733078702d46333735362e706e673f77696474683d363030" alt="Views" data-canonical-src="https://cacoo.com/diagrams/OnjKgBHat0kHs0xp-F3756.png?width=600" style="max-width:100%;"></a></p>

<p>Pushing SPC key, the detail buffer pops up. Pushing SPC key again, the buffer is closed.
<a href="https://camo.githubusercontent.com/75b096ab19bbf3865d9edd8e9388a8859f11debc/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f4f6e6a4b6742486174306b48733078702d38334338302e706e673f77696474683d363030" target="_blank"><img src="https://camo.githubusercontent.com/75b096ab19bbf3865d9edd8e9388a8859f11debc/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f4f6e6a4b6742486174306b48733078702d38334338302e706e673f77696474683d363030" alt="Pop up details" data-canonical-src="https://cacoo.com/diagrams/OnjKgBHat0kHs0xp-83C80.png?width=600" style="max-width:100%;"></a></p>

<p>Many information items are displayed in the Emacs buffer.
<a href="https://camo.githubusercontent.com/61db8f948f27ab1b2254ab2e5fae07da3aa0432d/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f4f6e6a4b6742486174306b48733078702d42393631422e706e673f77696474683d363030" target="_blank"><img src="https://camo.githubusercontent.com/61db8f948f27ab1b2254ab2e5fae07da3aa0432d/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f4f6e6a4b6742486174306b48733078702d42393631422e706e673f77696474683d363030" alt="View details" data-canonical-src="https://cacoo.com/diagrams/OnjKgBHat0kHs0xp-B961B.png?width=600" style="max-width:100%;"></a></p>

<h2><a id="user-content-installation" class="anchor" href="#installation" aria-hidden="true"><span class="octicon octicon-link"></span></a>Installation</h2>

<p>To use this program, locate this file to load-path directory,
and add the following code to your .emacs.</p>

<div class="highlight highlight-source-lisp"><pre>(require 'calfw)</pre></div>

<p>Executing the command <code>cfw:open-calendar-buffer</code>, switch to the calendar buffer.
You can navigate the date like calendar.el.</p>

<p>Schedule data which are shown in the calendar view, are collected by a
list of the struct <code>cfw:source</code> objects through the named argument
variables <code>:contents-sources</code> and <code>:annotation-sources</code>. The former
source defines schedule contents. The later one does date
annotations like the moon phases.</p>

<p>This program gets the holidays using the function
<code>calendar-holiday-list</code>. See the document for the holidays.el and the Info text.</p>

<h2><a id="user-content-key-bindings" class="anchor" href="#key-bindings" aria-hidden="true"><span class="octicon octicon-link"></span></a>Key bindings</h2>

<p>In the calendar buffer and region, you can use following key bindings:</p>

<table><thead>
<tr>
<th>Navigation</th>
<th></th>
</tr>
</thead><tbody>
<tr>
<td>[left], b, h</td>
<td>Previous day</td>
</tr>
<tr>
<td>[right], f, l</td>
<td>Next day</td>
</tr>
<tr>
<td>[up], p, k</td>
<td>Previous week</td>
</tr>
<tr>
<td>[down], n, j</td>
<td>Next week</td>
</tr>
<tr>
<td>^</td>
<td>Week begin</td>
</tr>
<tr>
<td>$</td>
<td>Week end</td>
</tr>
<tr>
<td>[home]</td>
<td>First date in this month</td>
</tr>
<tr>
<td>[end]</td>
<td>Last date in this month</td>
</tr>
<tr>
<td>M-v, [PgUp], &lt;</td>
<td>Previous month</td>
</tr>
<tr>
<td>C-v, [PgDown], &gt;</td>
<td>Next month</td>
</tr>
<tr>
<td>t</td>
<td>Today</td>
</tr>
<tr>
<td>g</td>
<td>Absolute date (YYYY/MM/DD)</td>
</tr>
<tr>
<td>TAB</td>
<td>Next item in a day</td>
</tr>
</tbody></table>

<table><thead>
<tr>
<th>Changing View</th>
<th></th>
</tr>
</thead><tbody>
<tr>
<td>M</td>
<td>Month view</td>
</tr>
<tr>
<td>W</td>
<td>1 Week view</td>
</tr>
<tr>
<td>T</td>
<td>2 Week view</td>
</tr>
<tr>
<td>D</td>
<td>Day view</td>
</tr>
</tbody></table>

<table><thead>
<tr>
<th>Operation</th>
<th></th>
</tr>
</thead><tbody>
<tr>
<td>r</td>
<td>Refresh data and re-draw contents</td>
</tr>
<tr>
<td>SPC</td>
<td>Pop-up detail buffer (like Quicklook in Mac)</td>
</tr>
<tr>
<td>RET, [click]</td>
<td>Jump (howm, orgmode)</td>
</tr>
<tr>
<td>q</td>
<td>Bury buffer</td>
</tr>
</tbody></table>

<p>The buttons on the toolbar can be clicked.</p>

<h2><a id="user-content-add-ons" class="anchor" href="#add-ons" aria-hidden="true"><span class="octicon octicon-link"></span></a>Add-ons:</h2>

<p>Following programs are also useful:</p>

<ul>
<li>calfw-howm.el : Display howm schedules (<a href="http://howm.sourceforge.jp/index.html">http://howm.sourceforge.jp/index.html</a>)</li>
<li>calfw-ical.el : Display schedules of the iCalendar format, such as the google calendar.</li>
<li>calfw-org.el  : Display org schedules (<a href="http://orgmode.org/">http://orgmode.org/</a>)</li>
<li>calfw-cal.el  : Display diary schedules.</li>
</ul>

<h2><a id="user-content-setting-example" class="anchor" href="#setting-example" aria-hidden="true"><span class="octicon octicon-link"></span></a>Setting example:</h2>

<h3><a id="user-content-for-howm-users" class="anchor" href="#for-howm-users" aria-hidden="true"><span class="octicon octicon-link"></span></a>For howm users:</h3>

<div class="highlight highlight-source-lisp"><pre>(eval-after-load <span class="pl-s"><span class="pl-pds">"</span>howm-menu<span class="pl-pds">"</span></span> '(<span class="pl-c1">progn</span>
  (require 'calfw-howm)
  (cfw:install-howm-schedules)
  (define-key howm-mode-map (kbd <span class="pl-s"><span class="pl-pds">"</span>M-C<span class="pl-pds">"</span></span>) 'cfw:open-howm-calendar)
))</pre></div>

<p>If you are using Elscreen, here is useful.</p>

<div class="highlight highlight-source-lisp"><pre>(define-key howm-mode-map (kbd <span class="pl-s"><span class="pl-pds">"</span>M-C<span class="pl-pds">"</span></span>) 'cfw:elscreen-open-howm-calendar)</pre></div>

<p>You can display a calendar in your howm menu file.</p>

<pre><code>%here%(cfw:howm-schedule-inline)
</code></pre>

<p><a href="https://camo.githubusercontent.com/1416e559ea0d2e276327c1a2a2c429c1131ead9c/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f7672536349344b32516c6d44417066642d31463934312e706e673f77696474683d343530" target="_blank"><img src="https://camo.githubusercontent.com/1416e559ea0d2e276327c1a2a2c429c1131ead9c/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f7672536349344b32516c6d44417066642d31463934312e706e673f77696474683d343530" alt="howm menu embedding" data-canonical-src="https://cacoo.com/diagrams/vrScI4K2QlmDApfd-1F941.png?width=450" style="max-width:100%;"></a></p>

<h3><a id="user-content-for-org-users" class="anchor" href="#for-org-users" aria-hidden="true"><span class="octicon octicon-link"></span></a>For org users:</h3>

<pre><code>(require 'calfw-org)
</code></pre>

<p>Then, M-x <code>cfw:open-org-calendar</code>.</p>

<p><a href="https://camo.githubusercontent.com/585347cc96320b0ccff66bb9cff4e0320b42f984/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5336614a6e744736676947733434596e2d38394342322e706e673f77696474683d343530" target="_blank"><img src="https://camo.githubusercontent.com/585347cc96320b0ccff66bb9cff4e0320b42f984/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5336614a6e744736676947733434596e2d38394342322e706e673f77696474683d343530" alt="org-agenda and calfw-org" data-canonical-src="https://cacoo.com/diagrams/S6aJntG6giGs44Yn-89CB2.png?width=450" style="max-width:100%;"></a></p>

<h4><a id="user-content-filtering-agenda-items" class="anchor" href="#filtering-agenda-items" aria-hidden="true"><span class="octicon octicon-link"></span></a>Filtering agenda items</h4>

<p>You can choose agenda items with <code>cfw:org-agenda-schedule-args</code>, like following code:</p>

<div class="highlight highlight-source-lisp"><pre>(<span class="pl-c1">setq</span> cfw:org-agenda-schedule-args '(:timestamp))</pre></div>

<p>This setting restricts items containing a date stamp or date range matching the selected date.
If <code>cfw:org-agenda-schedule-args</code> is <code>nil</code>, the default customize variable <code>org-agenda-entry-types</code> is used. For the further information, please refer the orgmode document.</p>

<ul>
<li><a href="http://orgmode.org/worg/org-tutorials/org-custom-agenda-commands.html#sec-5">Worg: Speeding up custom agenda commands</a></li>
</ul>

<h4><a id="user-content-orgmode-like-key-bindng" class="anchor" href="#orgmode-like-key-bindng" aria-hidden="true"><span class="octicon octicon-link"></span></a>Orgmode like key bindng</h4>

<p>You can use another key binding like org agenda buffer, setting <code>cfw:org-overwrite-default-keybinding</code> to non-nil, like following code:</p>

<div class="highlight highlight-source-lisp"><pre>(<span class="pl-c1">setq</span> cfw:org-overwrite-default-keybinding <span class="pl-c1">t</span>)</pre></div>

<p>Then, following key bindings are overwritten:</p>

<table><thead>
<tr>
<th>key</th>
<th>function</th>
</tr>
</thead><tbody>
<tr>
<td>g</td>
<td>Refresh data and re-draw contents (cfw:refresh-calendar-buffer)</td>
</tr>
<tr>
<td>j</td>
<td>Goto the specified date (cfw:org-goto-date)</td>
</tr>
<tr>
<td>k</td>
<td>org-capture</td>
</tr>
<tr>
<td>x</td>
<td>Close calfw and other buffers opened by calfw-org (cfw:org-clean-exit)</td>
</tr>
<tr>
<td>d</td>
<td>Day view (cfw:change-view-day)</td>
</tr>
<tr>
<td>v d</td>
<td>Day view (cfw:change-view-day)</td>
</tr>
<tr>
<td>v w</td>
<td>1 Week view (cfw:change-view-week)</td>
</tr>
<tr>
<td>v m</td>
<td>Month View (cfw:change-view-month)</td>
</tr>
</tbody></table>

<h4><a id="user-content-synchronization-with-google-calendar" class="anchor" href="#synchronization-with-google-calendar" aria-hidden="true"><span class="octicon octicon-link"></span></a>Synchronization with google calendar</h4>

<p>Here is the program which helps synchronization schedule items between org and google calendar, and also collaborates with calfw.</p>

<ul>
<li><a href="https://github.com/myuhe/org-gcal.el">https://github.com/myuhe/org-gcal.el</a>

<ul>
<li><a href="http://sheephead.homelinux.org/2014/03/14/7023/">Org-modeとGoogle calendar間で予定をやりとりするorg-gcal.elというのを作りました</a></li>
<li><a href="http://sheephead.homelinux.org/2014/03/15/7035/">calfwとorg-gcalの連携</a></li>
</ul></li>
</ul>

<h3><a id="user-content-for-ical-google-calendar-users" class="anchor" href="#for-ical-google-calendar-users" aria-hidden="true"><span class="octicon octicon-link"></span></a>For iCal (Google Calendar) users:</h3>

<p>Here is a minimum sample code:</p>

<div class="highlight highlight-source-lisp"><pre>(require 'calfw-ical)
(cfw:open-ical-calendar <span class="pl-s"><span class="pl-pds">"</span>http://www.google.com/calendar/ical/.../basic.ics<span class="pl-pds">"</span></span>)</pre></div>

<p><a href="https://camo.githubusercontent.com/95fea69b30f65b836d74b815a3f4fceb1dfd6aa4/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f7672536349344b32516c6d44417066642d35453830382e706e673f77696474683d343530" target="_blank"><img src="https://camo.githubusercontent.com/95fea69b30f65b836d74b815a3f4fceb1dfd6aa4/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f7672536349344b32516c6d44417066642d35453830382e706e673f77696474683d343530" alt="Google Calendar and calfw-ical" data-canonical-src="https://cacoo.com/diagrams/vrScI4K2QlmDApfd-5E808.png?width=450" style="max-width:100%;"></a></p>

<p>Here is the add-on program which communicate with google calendar via API:</p>

<ul>
<li><a href="http://sheephead.homelinux.org/2011/01/18/6559/">calfwからGoogleカレンダーを編集するcalfw-gcal.elを書いてみた</a>

<ul>
<li><a href="https://github.com/myuhe/calfw-gcal.el/blob/master/calfw-gcal.el">https://github.com/myuhe/calfw-gcal.el/blob/master/calfw-gcal.el</a></li>
</ul></li>
</ul>

<h3><a id="user-content-for-diary-users" class="anchor" href="#for-diary-users" aria-hidden="true"><span class="octicon octicon-link"></span></a>For diary users:</h3>

<p>Here is a minimum sample code:</p>

<div class="highlight highlight-source-lisp"><pre>(require 'calfw-cal)</pre></div>

<p>Then, M-x <code>cfw:open-diary-calendar</code>.</p>

<p>If you see a blank entry for each day, set the variable <code>diary-list-include-blanks</code> to nil.</p>

<h3><a id="user-content-general-setting" class="anchor" href="#general-setting" aria-hidden="true"><span class="octicon octicon-link"></span></a>General setting</h3>

<p>The calfw view can display many schedule items, gathering some schedule sources.
Using the function <code>cfw:open-calendar-buffer</code> is the general way to display the schedules.</p>

<p>Here is the sample code:</p>

<div class="highlight highlight-source-lisp"><pre>(require 'calfw-cal)
(require 'calfw-ical)
(require 'calfw-howm)
(require 'calfw-org)

(<span class="pl-k">defun</span> <span class="pl-en">my-open-calendar</span> ()
  (interactive)
  (cfw:open-calendar-buffer
   :contents-sources
   (<span class="pl-c1">list</span>
    (cfw:org-create-source <span class="pl-s"><span class="pl-pds">"</span>Green<span class="pl-pds">"</span></span>)  <span class="pl-c">; orgmode source</span>
    (cfw:howm-create-source <span class="pl-s"><span class="pl-pds">"</span>Blue<span class="pl-pds">"</span></span>)  <span class="pl-c">; howm source</span>
    (cfw:cal-create-source <span class="pl-s"><span class="pl-pds">"</span>Orange<span class="pl-pds">"</span></span>) <span class="pl-c">; diary source</span>
    (cfw:ical-create-source <span class="pl-s"><span class="pl-pds">"</span>Moon<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>~/moon.ics<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>Gray<span class="pl-pds">"</span></span>)  <span class="pl-c">; ICS source1</span>
    (cfw:ical-create-source <span class="pl-s"><span class="pl-pds">"</span>gcal<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>https://..../basic.ics<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>IndianRed<span class="pl-pds">"</span></span>) <span class="pl-c">; google calendar ICS</span>
   ))) </pre></div>

<p>The function <code>cfw:open-calendar-buffer</code> receives schedules sources via
the named argument <code>:contents-sources</code>.</p>

<p>One can customize the keymap on the calendar buffer with the named
argument <code>:custom-map</code> of <code>cfw:open-calendar-buffer</code>.</p>

<h2><a id="user-content-customize" class="anchor" href="#customize" aria-hidden="true"><span class="octicon octicon-link"></span></a>Customize</h2>

<h3><a id="user-content-holidays" class="anchor" href="#holidays" aria-hidden="true"><span class="octicon octicon-link"></span></a>Holidays</h3>

<p>The calfw collects holidays from the customize variable
<code>calendar-holidays</code> which belongs to holidays.el in the Emacs. See the
document and source of holidays.el for details.</p>

<h3><a id="user-content-format-of-month-and-week-days" class="anchor" href="#format-of-month-and-week-days" aria-hidden="true"><span class="octicon octicon-link"></span></a>Format of month and week days</h3>

<p>The calfw uses some customization variables in the calendar.el.</p>

<p>Here is a customization code:</p>

<div class="highlight highlight-source-lisp"><pre><span class="pl-c">;; Month</span>
(<span class="pl-c1">setq</span> calendar-month-name-array
  [<span class="pl-s"><span class="pl-pds">"</span>January<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>February<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>March<span class="pl-pds">"</span></span>     <span class="pl-s"><span class="pl-pds">"</span>April<span class="pl-pds">"</span></span>   <span class="pl-s"><span class="pl-pds">"</span>May<span class="pl-pds">"</span></span>      <span class="pl-s"><span class="pl-pds">"</span>June<span class="pl-pds">"</span></span>
   <span class="pl-s"><span class="pl-pds">"</span>July<span class="pl-pds">"</span></span>    <span class="pl-s"><span class="pl-pds">"</span>August<span class="pl-pds">"</span></span>   <span class="pl-s"><span class="pl-pds">"</span>September<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>October<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>November<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>December<span class="pl-pds">"</span></span>])

<span class="pl-c">;; Week days</span>
(<span class="pl-c1">setq</span> calendar-day-name-array
      [<span class="pl-s"><span class="pl-pds">"</span>Sunday<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>Monday<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>Tuesday<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>Wednesday<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>Thursday<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>Friday<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>Saturday<span class="pl-pds">"</span></span>])

<span class="pl-c">;; First day of the week</span>
(<span class="pl-c1">setq</span> calendar-week-start-day <span class="pl-c1">0</span>) <span class="pl-c">; 0:Sunday, 1:Monday</span></pre></div>

<h3><a id="user-content-faces" class="anchor" href="#faces" aria-hidden="true"><span class="octicon octicon-link"></span></a>Faces</h3>

<p>One can customize the faces.</p>

<p>Here is a template code for face customization:</p>

<div class="highlight highlight-source-lisp"><pre>(custom-set-faces
 '(cfw:face-title ((<span class="pl-c1">t</span> (:foreground <span class="pl-s"><span class="pl-pds">"</span>#f0dfaf<span class="pl-pds">"</span></span> :weight bold :height <span class="pl-c1">2.0</span> :inherit variable-pitch))))
 '(cfw:face-header ((<span class="pl-c1">t</span> (:foreground <span class="pl-s"><span class="pl-pds">"</span>#d0bf8f<span class="pl-pds">"</span></span> :weight bold))))
 '(cfw:face-sunday ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>#cc9393<span class="pl-pds">"</span></span> :background <span class="pl-s"><span class="pl-pds">"</span>grey10<span class="pl-pds">"</span></span> :weight bold)))
 '(cfw:face-saturday ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>#8cd0d3<span class="pl-pds">"</span></span> :background <span class="pl-s"><span class="pl-pds">"</span>grey10<span class="pl-pds">"</span></span> :weight bold)))
 '(cfw:face-holiday ((<span class="pl-c1">t</span> :background <span class="pl-s"><span class="pl-pds">"</span>grey10<span class="pl-pds">"</span></span> :foreground <span class="pl-s"><span class="pl-pds">"</span>#8c5353<span class="pl-pds">"</span></span> :weight bold)))
 '(cfw:face-grid ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>DarkGrey<span class="pl-pds">"</span></span>)))
 '(cfw:face-default-content ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>#bfebbf<span class="pl-pds">"</span></span>)))
 '(cfw:face-periods ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>cyan<span class="pl-pds">"</span></span>)))
 '(cfw:face-day-title ((<span class="pl-c1">t</span> :background <span class="pl-s"><span class="pl-pds">"</span>grey10<span class="pl-pds">"</span></span>)))
 '(cfw:face-default-day ((<span class="pl-c1">t</span> :weight bold :inherit cfw:face-day-title)))
 '(cfw:face-annotation ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>RosyBrown<span class="pl-pds">"</span></span> :inherit cfw:face-day-title)))
 '(cfw:face-disable ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>DarkGray<span class="pl-pds">"</span></span> :inherit cfw:face-day-title)))
 '(cfw:face-today-title ((<span class="pl-c1">t</span> :background <span class="pl-s"><span class="pl-pds">"</span>#7f9f7f<span class="pl-pds">"</span></span> :weight bold)))
 '(cfw:face-today ((<span class="pl-c1">t</span> :background: <span class="pl-s"><span class="pl-pds">"</span>grey10<span class="pl-pds">"</span></span> :weight bold)))
 '(cfw:face-select ((<span class="pl-c1">t</span> :background <span class="pl-s"><span class="pl-pds">"</span>#2f2f2f<span class="pl-pds">"</span></span>)))
 '(cfw:face-toolbar ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>Steelblue4<span class="pl-pds">"</span></span> :background <span class="pl-s"><span class="pl-pds">"</span>Steelblue4<span class="pl-pds">"</span></span>)))
 '(cfw:face-toolbar-button-off ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>Gray10<span class="pl-pds">"</span></span> :weight bold)))
 '(cfw:face-toolbar-button-on ((<span class="pl-c1">t</span> :foreground <span class="pl-s"><span class="pl-pds">"</span>Gray50<span class="pl-pds">"</span></span> :weight bold))))</pre></div>

<h3><a id="user-content-grid-frame" class="anchor" href="#grid-frame" aria-hidden="true"><span class="octicon octicon-link"></span></a>Grid frame</h3>

<p>Users can have nice unicode grid frame. However, in the some environment, the Emacs can not display the grid characters correctly. Please try following settings.</p>

<p>Grid setting example:</p>

<div class="highlight highlight-source-lisp"><pre><span class="pl-c">;; Default setting</span>
(<span class="pl-c1">setq</span> cfw:fchar-junction <span class="pl-c1">?+</span>
      cfw:fchar-vertical-line ?|
      cfw:fchar-horizontal-line <span class="pl-c1">?-</span>
      cfw:fchar-left-junction <span class="pl-c1">?+</span>
      cfw:fchar-right-junction <span class="pl-c1">?+</span>
      cfw:fchar-top-junction <span class="pl-c1">?+</span>
      cfw:fchar-top-left-corner <span class="pl-c1">?+</span>
      cfw:fchar-top-right-corner <span class="pl-c1">?+</span> )

<span class="pl-c">;; Unicode characters</span>
(<span class="pl-c1">setq</span> cfw:fchar-junction ?╋
      cfw:fchar-vertical-line ?┃
      cfw:fchar-horizontal-line ?━
      cfw:fchar-left-junction ?┣
      cfw:fchar-right-junction ?┫
      cfw:fchar-top-junction ?┯
      cfw:fchar-top-left-corner ?┏
      cfw:fchar-top-right-corner ?┓)

<span class="pl-c">;; Another unicode chars</span>
(<span class="pl-c1">setq</span> cfw:fchar-junction ?╬
      cfw:fchar-vertical-line ?║
      cfw:fchar-horizontal-line ?═
      cfw:fchar-left-junction ?╠
      cfw:fchar-right-junction ?╣
      cfw:fchar-top-junction ?╦
      cfw:fchar-top-left-corner ?╔
      cfw:fchar-top-right-corner ?╗)</pre></div>

<h3><a id="user-content-line-breaking" class="anchor" href="#line-breaking" aria-hidden="true"><span class="octicon octicon-link"></span></a>Line breaking</h3>

<p>If a content string is longer than the cell width, the calfw breaks into the multiple lines.
In the current implementation, the Calfw has 3 strategies: none, simple and wordwrap. The variable <code>cfw:render-line-breaker</code> selects the strategy to break lines.</p>

<ul>
<li><code>cfw:render-line-breaker-none</code>

<ul>
<li>Never breaks lines. Longer contents are truncated.</li>
</ul></li>
<li><code>cfw:render-line-breaker-simple</code> (default)

<ul>
<li>This strategy breaks lines with rigid width. This may be not so beautiful, but In the most cases it looks good.</li>
</ul></li>
<li><code>cfw:render-line-breaker-wordwrap</code>

<ul>
<li>This strategy breaks lines with the emacs function <code>fill-region</code>. Although, the line breaking algorithm of the Emacs is not so smart as more complicated ones, such as Knuth/Plass algorithm, this strategy is better than the simple one.</li>
</ul></li>
</ul>

<h2><a id="user-content-calfw-framework-details" class="anchor" href="#calfw-framework-details" aria-hidden="true"><span class="octicon octicon-link"></span></a>Calfw framework details</h2>

<p>In this section, I would explain how to add a new calendar source and how to embed the calfw component in the other applications.</p>

<h3><a id="user-content-how-to-add-a-new-calendar-source" class="anchor" href="#how-to-add-a-new-calendar-source" aria-hidden="true"><span class="octicon octicon-link"></span></a>How to add a new calendar source?</h3>

<p>Defining the <code>cfw:source</code> object, one can extend calfw calendar source.</p>

<h4><a id="user-content-struct-cfwsource-details" class="anchor" href="#struct-cfwsource-details" aria-hidden="true"><span class="octicon octicon-link"></span></a>struct cfw:source details</h4>

<p>The struct <code>cfw:source</code> is a simple data type defined by cl-defstruct.</p>

<p>Here is the details of the slot members of <code>cfw:source</code>.</p>

<table><thead>
<tr>
<th>slot name</th>
<th>description</th>
</tr>
</thead><tbody>
<tr>
<td>name</td>
<td>[required] Source name. This name is shown at the status bar.</td>
</tr>
<tr>
<td>data</td>
<td>[required] Data function which returns calendar contents. The function details are described in the next section.</td>
</tr>
<tr>
<td>update</td>
<td>[option] Update function. Calfw calls this function when this source needs to refresh the data.</td>
</tr>
<tr>
<td>color</td>
<td>[option] Color string for this source.  Color names those are shown by <code>M-x list-colors-display</code> or RGB hex format like "#abcdef".</td>
</tr>
<tr>
<td>period-fgcolor</td>
<td>[option] Foreground color for period items. The default color is white or black.</td>
</tr>
<tr>
<td>period-bgcolor</td>
<td>[option] Background color for period items. The default color is <code>cfw:source-color</code>.</td>
</tr>
<tr>
<td>opt-face</td>
<td>[option] Additional options for the normal item face.  Ex. <code>:opt-face '(:weight bold)</code></td>
</tr>
<tr>
<td>opt-period-face</td>
<td>[option] Additional options for the period item face.</td>
</tr>
</tbody></table>

<p>Only <code>name</code> and <code>data</code> slots are essential. Many slots are visual options.</p>

<p>In many cases, one has to specify only the <code>color</code> slot for visual,
because the calfw chooses appropriate colors for the rest color options.</p>

<h4><a id="user-content-cfwsource-data-details" class="anchor" href="#cfwsource-data-details" aria-hidden="true"><span class="octicon octicon-link"></span></a>cfw:source-data details</h4>

<p>This section explains what objects the function-slot <code>cfw:source-data</code> should return.</p>

<p>The function-slot <code>cfw:source-data</code> receives two arguments, start and
end date of the query period, and returns a list of instances of <code>cfw:event</code> struct.</p>

<p>Here is a simple example. </p>

<p><code>cfw:source-data example1:</code></p>

<div class="highlight highlight-source-lisp"><pre><span class="pl-c">;; cfw:source-data example</span>
(<span class="pl-k">defun</span> <span class="pl-en">sample-data1</span> (b e)
  (<span class="pl-c1">list</span>
    (make-cfw:event :title <span class="pl-s"><span class="pl-pds">"</span>item1<span class="pl-pds">"</span></span>   :start-date  (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">1</span> <span class="pl-c1">2011</span>))
    (make-cfw:event :title <span class="pl-s"><span class="pl-pds">"</span>item2-1<span class="pl-pds">"</span></span> :start-date  (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">10</span> <span class="pl-c1">2011</span>))
    (make-cfw:event :title <span class="pl-s"><span class="pl-pds">"</span>item2-2<span class="pl-pds">"</span></span> :start-date  (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">10</span> <span class="pl-c1">2011</span>))
    ))

(cfw:open-calendar-buffer
  :date (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">1</span> <span class="pl-c1">2011</span>)
  :contents-sources
   (<span class="pl-c1">list</span> 
     (make-cfw:source
      :name <span class="pl-s"><span class="pl-pds">"</span>test1<span class="pl-pds">"</span></span> :data 'sample-data1)))</pre></div>

<p>Evaluating this code in the scratch buffer, following result is displayed.</p>

<p><a href="https://camo.githubusercontent.com/a43a34a5e48d8cb5d445a67e9b75b00beaf4be43/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d35303331302e706e673f77696474683d343530" target="_blank"><img src="https://camo.githubusercontent.com/a43a34a5e48d8cb5d445a67e9b75b00beaf4be43/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d35303331302e706e673f77696474683d343530" alt="Simple source example" data-canonical-src="https://cacoo.com/diagrams/P6baUrxEQj4NYheV-50310.png?width=450" style="max-width:100%;"></a></p>

<p>The date is specified by <code>cfw:date</code> type, <code>([month] [day] [year])</code>. This format is commonly used in calendar.el and orgmode.
(I diagrammed the exchange ways for some time and date formats in Emacs, <a href="https://cacoo.com/diagrams/lsA64PTazlLTbSwR">here</a>.)</p>

<p>Period items are little different. One period item is specified by
<code>:start-date</code> and <code>:end-date</code>, and the nested list which has the symbol <code>periods</code> at the head collects them, like the following code.</p>

<p><code>cfw:source-data example2:</code></p>

<div class="highlight highlight-source-lisp"><pre><span class="pl-c">;; cfw:source-data period items</span>
(<span class="pl-k">defun</span> <span class="pl-en">sample-data2</span> (b e)
  (<span class="pl-c1">list</span>
    (make-cfw:event :title <span class="pl-s"><span class="pl-pds">"</span>Item1<span class="pl-pds">"</span></span>
          :start-date  (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">15</span> <span class="pl-c1">2011</span>))
    (<span class="pl-c1">list</span> 'periods
      (make-cfw:event :title <span class="pl-s"><span class="pl-pds">"</span>Period item<span class="pl-pds">"</span></span>
          :start-date (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">8</span> <span class="pl-c1">2011</span>)
          :end-date   (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">9</span> <span class="pl-c1">2011</span>)
          :description <span class="pl-s"><span class="pl-pds">"</span>Period item description<span class="pl-pds">"</span></span>)
      (make-cfw:event :title <span class="pl-s"><span class="pl-pds">"</span>Next item<span class="pl-pds">"</span></span>
          :start-date (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">11</span> <span class="pl-c1">2011</span>)
          :end-date   (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">12</span> <span class="pl-c1">2011</span>)
          :description <span class="pl-s"><span class="pl-pds">"</span>Next item description<span class="pl-pds">"</span></span>))))

(cfw:open-calendar-buffer
  :date (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">1</span> <span class="pl-c1">2011</span>)
  :contents-sources
   (<span class="pl-c1">list</span> 
     (make-cfw:source
      :name <span class="pl-s"><span class="pl-pds">"</span>test2<span class="pl-pds">"</span></span> :data 'sample-data2)))</pre></div>

<p>Evaluating this code in the scratch buffer, following result is displayed.</p>

<p><a href="https://camo.githubusercontent.com/9df9ed9f86fd39689ca48b0151762a5ecb4b850e/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d34303331352e706e673f77696474683d343530" target="_blank"><img src="https://camo.githubusercontent.com/9df9ed9f86fd39689ca48b0151762a5ecb4b850e/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d34303331352e706e673f77696474683d343530" alt="Range items example" data-canonical-src="https://cacoo.com/diagrams/P6baUrxEQj4NYheV-40315.png?width=450" style="max-width:100%;"></a></p>

<p>Here are other detailed specifications.</p>

<ul>
<li>The both start and end date are included by the query period.</li>
<li>The items those aren't included in the query period are ignored.</li>
<li><code>cfw:source-data</code> should return a value as fast as possible, because users are waiting for the result. Caching is good idea.</li>
<li>Schedule items don't have to be ordered. Duplicated items may be gathered.</li>
<li>In the day cell, the items are sorted by <code>string-lessp</code>, i.e. numerical and alphabetical order.

<ul>
<li>The ordering function can be customized by the named argument <code>:sorter</code> of the component construction.</li>
</ul></li>
</ul>

<p>In the above examples, the dates of the schedule items are fixed. The actual sources generate result values by the programs. The codes of calfw add-ons may be helpful for your implementation.</p>

<h5><a id="user-content-cfwevent-struct-detail" class="anchor" href="#cfwevent-struct-detail" aria-hidden="true"><span class="octicon octicon-link"></span></a>cfw:event struct detail</h5>

<p>The <code>cfw:event</code> struct:</p>

<table><thead>
<tr>
<th>slot name</th>
<th>description</th>
</tr>
</thead><tbody>
<tr>
<td><code>title</code></td>
<td>event title [string]</td>
</tr>
<tr>
<td><code>start-date</code></td>
<td>start date of the event [cfw:date]</td>
</tr>
<tr>
<td><code>start-time</code></td>
<td>start time of the event (optional)</td>
</tr>
<tr>
<td><code>end-date</code></td>
<td>end date of the event <a href="/kiwanami/emacs-calfw/blob/master/optional">cfw:date</a></td>
</tr>
<tr>
<td><code>end-time</code></td>
<td>end of the event (optional)</td>
</tr>
<tr>
<td><code>description</code></td>
<td>event description <a href="/kiwanami/emacs-calfw/blob/master/optional">string</a></td>
</tr>
<tr>
<td><code>location</code></td>
<td>location <a href="/kiwanami/emacs-calfw/blob/master/optional">string</a></td>
</tr>
<tr>
<td><code>source</code></td>
<td>[internal] source of the event</td>
</tr>
</tbody></table>

<h5><a id="user-content-event-formatting" class="anchor" href="#event-formatting" aria-hidden="true"><span class="octicon octicon-link"></span></a>Event formatting</h5>

<p>The framework has several formatting functions for <code>cfw:event</code> instances.
The functions are used by the calfw plugins (cal,ical, etc) to display in a common way.</p>

<table><thead>
<tr>
<th>Format function</th>
<th>Description</th>
</tr>
</thead><tbody>
<tr>
<td><code>cfw:event-overview</code></td>
<td>To get an overview of the event (month, 2-week &amp; week view)</td>
</tr>
<tr>
<td><code>cfw:event-days-overview</code></td>
<td>Overview in day-view.</td>
</tr>
<tr>
<td><code>cfw:event-period-overview</code></td>
<td>Overview of periods (same for all views)</td>
</tr>
<tr>
<td><code>cfw:event-detail</code></td>
<td>Detailed information of the event for the detail-view</td>
</tr>
</tbody></table>

<p>The formatting can be customized by the user with several formatting strings:</p>

<ul>
<li><code>cfw:event-format-overview</code></li>
<li><code>cfw:event-format-days-overview</code></li>
<li><code>cfw:event-format-period-overview</code></li>
<li><code>cfw:event-format-detail</code></li>
<li><code>cfw:event-format-title</code></li>
<li><code>cfw:event-format-start-date</code></li>
<li><code>cfw:event-format-start-time</code></li>
<li><code>cfw:event-format-end-date</code></li>
<li><code>cfw:event-format-end-time</code></li>
<li><code>cfw:event-format-location</code></li>
<li><code>cfw:event-format-description</code></li>
</ul>

<h4><a id="user-content-examples" class="anchor" href="#examples" aria-hidden="true"><span class="octicon octicon-link"></span></a>Examples</h4>

<ul>
<li><a href="https://gist.github.com/kiwanami/d77d9669440f3336bb9d">calfw-git.el</a>

<ul>
<li>Displaying git commit history items in calfw calendar view</li>
</ul></li>
<li><a href="https://gist.github.com/kiwanami/1fd257fc1e8907d4d92e">calfw-syobocal.el</a>

<ul>
<li>Retrieving schedule items via Web API and displaying them in calfw calendar view</li>
</ul></li>
</ul>

<h4><a id="user-content-another-way-to-define-schedule-items-legacy-method" class="anchor" href="#another-way-to-define-schedule-items-legacy-method" aria-hidden="true"><span class="octicon octicon-link"></span></a>Another way to define schedule items (legacy method)</h4>

<p><em>This subsection explains legacy method to define schedule items, so as for users to read old source codes. We should not use this method in the future.</em></p>

<p>The function-slot <code>cfw:source-data</code> receives two arguments, start and
end date of the query period, and returns an alist that consists of
([date] . ([item1] [item2] ... )).</p>

<p>Here is a simple example. </p>

<p><code>cfw:source-data example1:</code></p>

<div class="highlight highlight-source-lisp"><pre><span class="pl-c">;; cfw:source-data example</span>
(<span class="pl-k">defun</span> <span class="pl-en">sample-data1</span> (b e)
  '(
    ((<span class="pl-c1">1</span>  <span class="pl-c1">1</span> <span class="pl-c1">2011</span>) . (<span class="pl-s"><span class="pl-pds">"</span>item1<span class="pl-pds">"</span></span>))
    ((<span class="pl-c1">1</span> <span class="pl-c1">10</span> <span class="pl-c1">2011</span>) . (<span class="pl-s"><span class="pl-pds">"</span>item2-1<span class="pl-pds">"</span></span> <span class="pl-s"><span class="pl-pds">"</span>item2-2<span class="pl-pds">"</span></span>))
    ))

(cfw:open-calendar-buffer
  :date (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">1</span> <span class="pl-c1">2011</span>)
  :contents-sources
   (<span class="pl-c1">list</span> 
     (make-cfw:source
      :name <span class="pl-s"><span class="pl-pds">"</span>test1<span class="pl-pds">"</span></span> :data 'sample-data1)))</pre></div>

<p>Period items are little different. One period item is specified by
<code>([start date] [end date] [content])</code> and the <code>periods</code> record of the
alist collects them as a list, like the following code.</p>

<p><code>cfw:source-data example2:</code></p>

<div class="highlight highlight-source-lisp"><pre><span class="pl-c">;; cfw:source-data period items</span>
(<span class="pl-k">defun</span> <span class="pl-en">sample-data2</span> (b e)
  '(
    ((<span class="pl-c1">1</span>  <span class="pl-c1">8</span> <span class="pl-c1">2011</span>) . (<span class="pl-s"><span class="pl-pds">"</span>item1<span class="pl-pds">"</span></span>))
     (periods
      ((<span class="pl-c1">1</span> <span class="pl-c1">8</span> <span class="pl-c1">2011</span>) (<span class="pl-c1">1</span> <span class="pl-c1">9</span> <span class="pl-c1">2011</span>) <span class="pl-s"><span class="pl-pds">"</span>period item<span class="pl-pds">"</span></span>)
      ((<span class="pl-c1">1</span> <span class="pl-c1">11</span> <span class="pl-c1">2011</span>) (<span class="pl-c1">1</span> <span class="pl-c1">12</span> <span class="pl-c1">2011</span>) <span class="pl-s"><span class="pl-pds">"</span>next item<span class="pl-pds">"</span></span>))
    ))
<span class="pl-c">;; (A . (B C) ) is equivalent to (A B C)</span>

(cfw:open-calendar-buffer
  :date (cfw:date <span class="pl-c1">1</span> <span class="pl-c1">1</span> <span class="pl-c1">2011</span>)
  :contents-sources
   (<span class="pl-c1">list</span> 
     (make-cfw:source
      :name <span class="pl-s"><span class="pl-pds">"</span>test2<span class="pl-pds">"</span></span> :data 'sample-data2)))</pre></div>

<h3><a id="user-content-how-to-embed-the-calfw-component-in-the-other-applications" class="anchor" href="#how-to-embed-the-calfw-component-in-the-other-applications" aria-hidden="true"><span class="octicon octicon-link"></span></a>How to embed the calfw component in the other applications?</h3>

<p>In this section, the details of calfw components would be explained so as for users to extend calfw in themselves.</p>

<p>Calfw is built on the MVC architecture, using simple structure objects and modules employed by naming rules.</p>

<h4><a id="user-content-calfw-component" class="anchor" href="#calfw-component" aria-hidden="true"><span class="octicon octicon-link"></span></a>Calfw component</h4>

<p>Calfw has three destination components to display the calendar.</p>

<ul>
<li>Independent buffer</li>
<li>Region in the other buffer</li>
<li>Text output</li>
</ul>

<h5><a id="user-content-buffer" class="anchor" href="#buffer" aria-hidden="true"><span class="octicon octicon-link"></span></a>Buffer</h5>

<p>The 'buffer' destination displays the calendar view as ordinary Emacs applications do.</p>

<p>The function <code>cfw:open-calendar-buffer</code> makes a new calendar buffer (calfw buffer) and displays it by <code>switch-to-buffer</code>. The major mode of the calfw buffer is <code>cfw:calendar-mode</code> and the keymap <code>cfw:calendar-mode-map</code> is bound.</p>

<p>This destination is easy to use for applications and users, because the buffer is usual application boundary and users know how to use buffers.</p>

<h5><a id="user-content-region" class="anchor" href="#region" aria-hidden="true"><span class="octicon octicon-link"></span></a>Region</h5>

<p>The 'Region' destination embeds the calendar view in the buffer which is managed by the other applications. This destination can give the other applications a nice calendar view. See the howm embedding for example.</p>

<p>Let's try a demonstration. Evaluate this code in your scratch buffer.</p>

<p>Region destination example:</p>

<div class="highlight highlight-source-lisp"><pre><span class="pl-c">;; Evaluate this code in the scratch buffer</span>
(require 'calfw)
(cfw:create-calendar-component-region :height <span class="pl-c1">10</span>)</pre></div>

<p>Then, the calendar view will be embedded in the scratch buffer like the following screenshot. You can navigate the calfw view in the buffer. Undoing for the some times, you can remove the calfw view.</p>

<p><a href="https://camo.githubusercontent.com/20c2837bcd3a81924de7027b8025130503047715/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d42393634392e706e673f77696474683d363030" target="_blank"><img src="https://camo.githubusercontent.com/20c2837bcd3a81924de7027b8025130503047715/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d42393634392e706e673f77696474683d363030" alt="calfw in the scratch buffer" data-canonical-src="https://cacoo.com/diagrams/P6baUrxEQj4NYheV-B9649.png?width=600" style="max-width:100%;"></a></p>

<p>Because this destination never interacts anything out of the region and has its own key-binds as a text property, users can easily embed a calendar view in the other applications.</p>

<h5><a id="user-content-text" class="anchor" href="#text" aria-hidden="true"><span class="octicon octicon-link"></span></a>Text</h5>

<p>The 'text' destination generates just a text which represent calfw view. The function <code>cfw:get-calendar-text</code> returns the text.</p>

<h5><a id="user-content-destination-and-view" class="anchor" href="#destination-and-view" aria-hidden="true"><span class="octicon octicon-link"></span></a>Destination and View</h5>

<p>Three destinations are explained as mentioned above. Although they have different appearance, the application can operate the calfw component in the same way.</p>

<p>Let us call them 'destination', it is the abstraction of UI components.</p>

<p>The similar word 'view' means in which form the calfw displays the contents, for example, monthly form, two-weeks and weekly one and etc.</p>

<h4><a id="user-content-calfw-objects" class="anchor" href="#calfw-objects" aria-hidden="true"><span class="octicon octicon-link"></span></a>Calfw objects</h4>

<h5><a id="user-content-overview" class="anchor" href="#overview" aria-hidden="true"><span class="octicon octicon-link"></span></a>Overview</h5>

<p>The calfw consists of four objects:</p>

<ul>
<li><code>cfw:component</code> that gathers following objects up.</li>
<li><code>cfw:model</code> that manages calendar contents.</li>
<li><code>cfw:source</code> that defines schedule items.</li>
<li><code>cfw:dest</code> that is abstraction of destinations.</li>
</ul>

<p>The relations between the objects are displayed as UML class diagram (<a href="http://astah.change-vision.com/ja/:title=Astah">Diagrammed by astah</a>).</p>

<p><a href="https://camo.githubusercontent.com/031531dc1c2ca155b798f4c2a9aea120b78dea44/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d45433843362e706e67" target="_blank"><img src="https://camo.githubusercontent.com/031531dc1c2ca155b798f4c2a9aea120b78dea44/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d45433843362e706e67" alt="Overview for calfw objects" data-canonical-src="https://cacoo.com/diagrams/P6baUrxEQj4NYheV-EC8C6.png" style="max-width:100%;"></a></p>

<p><code>cfw:component</code> acts as Controller of MVC. It connects model object and destination one, and controls all events. It also gives the interface of calfw objects for the other applications.</p>

<p><code>cfw:model</code> and <code>cfw:source</code> act as Model of MVC. They manage the schedule contents and calendar logic.</p>

<p><code>cfw:dest</code> acts as View of MVC. It abstracts the common interface from UI destinations.</p>

<h5><a id="user-content-cfwcomponent" class="anchor" href="#cfwcomponent" aria-hidden="true"><span class="octicon octicon-link"></span></a>cfw:component</h5>

<p>The object <code>cfw:component</code> controls calfw objects and events.</p>

<p>The object has following information:</p>

<ul>
<li>References to <code>cfw:dest</code> object and <code>cfw:model</code> one.</li>
<li>Selected date on the calfw component.</li>
<li>View style.</li>
<li>Hooks

<ul>
<li><code>update-hooks</code></li>
<li><code>selection-change-hooks</code></li>
<li><code>click-hooks</code>.</li>
</ul></li>
</ul>

<p>The object has following operations:</p>

<ul>
<li>Getting object references to <code>cfw:dest</code>, <code>cfw:model</code>, belonging buffer and so on.</li>
<li>Getting and setting the selected date (<code>get-selected-date</code> / <code>set-selected-date</code>).</li>
<li>Getting and setting the view style (<code>get-view</code> / <code>set-view</code>).

<ul>
<li>The view style is a symbol, such as <code>month</code>, <code>two-weeks</code>, <code>week</code> and <code>day</code>.</li>
</ul></li>
<li>Resizing and refreshing the view (<code>resize</code> / <code>update</code>).</li>
<li>Managing hooks (<code>add-xxx-hook</code> / <code>remove-xxx-hook</code>)</li>
</ul>

<p>After construction of the calfw component, the destination object can not be changed.</p>

<p>The views are defined as a function and dispatched by the function <code>cfw:cp-dispatch-view-impl</code>.</p>

<p>The instance of the calfw component is stored at following places:</p>

<ul>
<li><code>buffer</code> destination: the buffer-local variable <code>cfw:component</code></li>
<li><code>region</code> destination: the text property <code>cfw:component</code></li>
<li><code>text</code> destination: N/A</li>
</ul>

<p>Calling the utility function <code>cfw:cp-get-component</code>, one can obtain the calfw instance at the appropriate places. The stateless functions, such as simple event handler functions, can use this function to get the instance.</p>

<p>The applications those have the state-full operations, however, should hold their own calfw instance for the safety object reference.</p>

<h5><a id="user-content-cfwmodel" class="anchor" href="#cfwmodel" aria-hidden="true"><span class="octicon octicon-link"></span></a>cfw:model</h5>

<p>The object <code>cfw:model</code> gathers schedule sources and gives a common interface for view functions to access the contents.</p>

<p>The object has following information:</p>

<ul>
<li>contents source objects (<code>contents-sources</code>)</li>
<li>annotation source objects (<code>annotation-sources</code>)</li>
<li>sorting function (<code>sorter</code>)</li>
</ul>

<p>The model object has no information of views and destinations, just manages schedule contents.</p>

<p>The holidays are retrieved from the global function <code>calendar-holiday-list</code> of calendar.el.</p>

<p>The schedule contents are modified through the model object after the component construction.</p>

<p>(In the current implementation, the model object is build by alist. Then, view functions adds some data as view model. I think it is not good solution, so the implementation may be modified in future.)</p>

<h5><a id="user-content-cfwdest" class="anchor" href="#cfwdest" aria-hidden="true"><span class="octicon octicon-link"></span></a>cfw:dest</h5>

<p>The object <code>cfw:dest</code> abstracts rendering destinations and gives a common interface of rendering operation to view functions.</p>

<p>The object has following information:</p>

<ul>
<li>destination buffer object (<code>buffer</code>)</li>
<li>region functions (<code>min-func</code>, <code>max-func</code>)</li>
<li>reference size (<code>width</code>, <code>height</code>)</li>
<li>clearing function (<code>clear-func</code>)</li>
<li>advice functions (<code>before-update-func</code>, <code>after-update-func</code>)</li>
<li>overlay data (<code>select-ol</code>, <code>today-ol</code>)</li>
</ul>

<p>In the current implementation, <code>cfw:dest</code> has three forms, buffer, region and text, mentioned above. Actually, the region destination is what I want. One buffer can have some destination objects, because all data (including local-variables and keymaps) are packed in the <code>cfw:dest</code> object.</p>

<h4><a id="user-content-application-design" class="anchor" href="#application-design" aria-hidden="true"><span class="octicon octicon-link"></span></a>Application design</h4>

<p>In this section, I would describe a simple guide line of application design using calfw.</p>

<p>One can use calfw as an application UI (like calfw-howm) or dialog UI for selecting a date (like calendar.el). The user application can choose the destination style: buffer or region. Switching between them is very easy.</p>

<p>The data presentation can be achieved by defining <code>cfw:source</code> object. It may be straightforward.</p>

<p>The input events by the user can be caught by hooks in the <code>cfw:component</code>. Then, the selected date is obtained by the function <code>cfw:cursor-to-nearest-date</code> or <code>cfw:cursor-to-date</code>. The current implementation, calfw can not treat a range on the calendar.</p>

<p>Generally, any events can be caught by the custom keymap which is given by the named argument <code>:custom-map</code> with component construction. Furthermore, because calfw reserves the text properties (face, keymap and so on) on the text that is returned by <code>cfw:source</code> objects, one can control event handling at each characters.</p>

<p>Once the model is modified, update function of the <code>cfw:component</code> object should be called to refresh the view.</p>

<p>The summary diagram is here.</p>

<p><a href="https://camo.githubusercontent.com/9edf73c222af3274d92fb051455eff7db7757e70/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d34363544342e706e67" target="_blank"><img src="https://camo.githubusercontent.com/9edf73c222af3274d92fb051455eff7db7757e70/68747470733a2f2f6361636f6f2e636f6d2f6469616772616d732f5036626155727845516a344e596865562d34363544342e706e67" alt="Summary of application design" data-canonical-src="https://cacoo.com/diagrams/P6baUrxEQj4NYheV-465D4.png" style="max-width:100%;"></a></p>

<p>See the calfw-howm.el code for more details.</p>

<h2><a id="user-content-history" class="anchor" href="#history" aria-hidden="true"><span class="octicon octicon-link"></span></a>History</h2>

<ul>
<li>2015/09/24 ver 1.5 : Fixed bugs and added some customize variables.</li>
<li>2015/02/27 ver 1.4 : Introduced cfw:event struct, improved some functions, fixed some bugs.</li>
<li>2011/10/10 ver 1.3 : Improved visual and navigation: multi-line, moving items in a day, diary mode and so on.</li>
<li>2011/07/20 ver 1.2 : Merged many patches and improved many and bug fixed.</li>
<li>2011/07/05 ver 1.0 : Refactored the whole implementation and design. Improved UI and views.</li>
<li>2011/01/07 ver 0.2.1 : Supporting org-agenda schedules.</li>
<li>2011/01/07 ver 0.1 : First release. Supporting howm and iCal schedules.</li>
</ul>

<hr>

<p>SAKURAI, Masashi
m.sakurai atmark kiwanami.net</p>

<p>Time-stamp: &lt;2015-09-24 11:47:57 sakurai&gt;</p>
</article>
  </div>


        </div>
      </div>
      <div class="modal-backdrop"></div>
    </div>
  </div>


    </div>

      <div class="container">
  <div class="site-footer" role="contentinfo">
    <ul class="site-footer-links right">
        <li><a href="https://status.github.com/" data-ga-click="Footer, go to status, text:status">Status</a></li>
      <li><a href="https://developer.github.com" data-ga-click="Footer, go to api, text:api">API</a></li>
      <li><a href="https://training.github.com" data-ga-click="Footer, go to training, text:training">Training</a></li>
      <li><a href="https://shop.github.com" data-ga-click="Footer, go to shop, text:shop">Shop</a></li>
        <li><a href="https://github.com/blog" data-ga-click="Footer, go to blog, text:blog">Blog</a></li>
        <li><a href="https://github.com/about" data-ga-click="Footer, go to about, text:about">About</a></li>
        <li><a href="https://github.com/pricing" data-ga-click="Footer, go to pricing, text:pricing">Pricing</a></li>

    </ul>

    <a href="https://github.com" aria-label="Homepage">
      <span class="mega-octicon octicon-mark-github" title="GitHub"></span>
</a>
    <ul class="site-footer-links">
      <li>&copy; 2015 <span title="0.06659s from github-fe145-cp1-prd.iad.github.net">GitHub</span>, Inc.</li>
        <li><a href="https://github.com/site/terms" data-ga-click="Footer, go to terms, text:terms">Terms</a></li>
        <li><a href="https://github.com/site/privacy" data-ga-click="Footer, go to privacy, text:privacy">Privacy</a></li>
        <li><a href="https://github.com/security" data-ga-click="Footer, go to security, text:security">Security</a></li>
        <li><a href="https://github.com/contact" data-ga-click="Footer, go to contact, text:contact">Contact</a></li>
        <li><a href="https://help.github.com" data-ga-click="Footer, go to help, text:help">Help</a></li>
    </ul>
  </div>
</div>



    
    
    

    <div id="ajax-error-message" class="flash flash-error">
      <span class="octicon octicon-alert"></span>
      <button type="button" class="flash-close js-flash-close js-ajax-error-dismiss" aria-label="Dismiss error">
        <span class="octicon octicon-x"></span>
      </button>
      Something went wrong with that request. Please try again.
    </div>


      <script crossorigin="anonymous" src="https://assets-cdn.github.com/assets/frameworks-f8473dece7242da6a20d52313634881b3975c52cebaa1e6c38157c0f26185691.js"></script>
      <script async="async" crossorigin="anonymous" src="https://assets-cdn.github.com/assets/github-8fbc9d96fbb3348f4ff61fe96efb1496d5f18a43b2573718b600725543c70af0.js"></script>
      
      
    <div class="js-stale-session-flash stale-session-flash flash flash-warn flash-banner hidden">
      <span class="octicon octicon-alert"></span>
      <span class="signed-in-tab-flash">You signed in with another tab or window. <a href="">Reload</a> to refresh your session.</span>
      <span class="signed-out-tab-flash">You signed out in another tab or window. <a href="">Reload</a> to refresh your session.</span>
    </div>
  </body>
</html>

